## ycmd 0+20240823+git8b61f19+ds

=== requirements.txt ===
regex    >= 2020.2.20
jedi     >= 0.16.0
watchdog >= 0.10.2
