=== debian/changelog ===
ycmd (0+20240823+git8b61f19+ds-3) unstable; urgency=medium

  * Import upstream 0+20250616+git9160b4e as patch series
  * Bump Standards-Version to 4.7.2 (no change needed)
  * Support Perl (perlnavigator) completion out of the box
  * Support Unicode 16 in testing

 -- David Kalnischkies <donkult@debian.org>  Mon, 08 Sep 2025 11:16:14 +0200
