=== debian/tests/control ===
Tests: upstream-unittest
Depends: @, python3-hamcrest, python3-webtest, python3-requests, python3-psutil,
         clangd,
         python3-jedi, python3-numpydoc,
         gopls, gccgo-go,
Restrictions: allow-stderr

Tests: upstream-unittest-node
Depends: @, python3-hamcrest, python3-webtest, python3-requests, python3-psutil,
         clangd,
         python3-jedi, python3-numpydoc,
         node-typescript,
         gopls, gccgo-go,
# nodejs is no longer available on armel
Restrictions: allow-stderr skip-not-installable

Tests: upstream-unittest-golang
Depends: @, python3-hamcrest, python3-webtest, python3-requests, python3-psutil,
         gopls, golang-go,
Restrictions: allow-stderr
